/**
 * chase-storage - chase's edition of cross-storage for x-domain localstorage
 *
 * @version   0.0.0-dev.1
 * @link      https://github.com/zendesk/cross-storage
 * @author    
 * @copyright Zendesk
 * @license   Apache-2.0
 */

!function(e){var l={init:function(e){var t=!0;try{window.localStorage||(t=!1)}catch(e){t=!1}if(!t)try{return window.parent.postMessage("cross-storage:unavailable","*")}catch(e){return}l._permissions=e||[],l._storageListeners={},l._installListener(),window.parent.postMessage("cross-storage:ready","*")},_installListener:function(){var e=l._listener;window.addEventListener?window.addEventListener("message",e,!1):window.attachEvent("onmessage",e)},_listener:function(e){var t,n,r,o,i,s,a;if(t="null"===e.origin?"file://":e.origin,"cross-storage:poll"===e.data)return window.parent.postMessage("cross-storage:ready",e.origin);if("cross-storage:ready"!==e.data){try{r=JSON.parse(e.data)}catch(e){return}if(r&&"string"==typeof r.method&&(o=r.method.split("cross-storage:")[1])){if(l._permitted(t,o))try{s=l["_"+o](r.params)}catch(e){i=e.message}else i="Invalid permissions for "+o;a=JSON.stringify({id:r.id,error:i,result:s}),n="file://"===t?"*":t,window.parent.postMessage(a,n)}}},_permitted:function(e,t){var n,r,o;if(n=["get","set","listen","del","clear","getKeys","listen"],"unlisten"===t&&(t="listen"),!l._inArray(t,n))return!1;for(r=0;r<l._permissions.length;r++)if((o=l._permissions[r]).origin instanceof RegExp&&o.allow instanceof Array&&o.origin.test(e)&&l._inArray(t,o.allow))return!0;return!1},_set:function(e){window.localStorage.setItem(e.key,e.value)},_get:function(e){var t,n,r,o;for(t=window.localStorage,n=[],r=0;r<e.keys.length;r++){try{o=t.getItem(e.keys[r])}catch(e){o=null}n.push(o)}return 1<n.length?n:n[0]},_listen:function(n){if(!(n.listenerId in l._storageListeners)){var e=function(e){if(e.storageArea===window.localStorage){var t={listenerId:n.listenerId,event:{key:e.key,newValue:e.newValue,oldValue:e.oldValue,url:e.url}};window.parent.postMessage(JSON.stringify(t),"*")}};l._storageListeners[n.listenerId]=e,window.addEventListener?window.addEventListener("storage",e,!1):window.attachEvent("onstorage",e)}},_unlisten:function(e){var t=l._storageListeners[e.listenerId];l._storageListeners[e.listenerId]=null,window.removeEventListener?window.removeEventListener("storage",t,!1):window.detachEvent("onstorage",t)},_del:function(e){for(var t=0;t<e.keys.length;t++)window.localStorage.removeItem(e.keys[t])},_clear:function(){window.localStorage.clear()},_getKeys:function(e){var t,n,r;for(r=[],n=window.localStorage.length,t=0;t<n;t++)r.push(window.localStorage.key(t));return r},_inArray:function(e,t){for(var n=0;n<t.length;n++)if(e===t[n])return!0;return!1},_now:function(){return"function"==typeof Date.now?Date.now():(new Date).getTime()}};"undefined"!=typeof module&&module.exports?module.exports=l:"undefined"!=typeof exports?exports.CrossStorageHub=l:"function"==typeof define&&define.amd?define([],function(){return l}):e.CrossStorageHub=l}(this);